function [iSels,a,A,Lambda,Gamma, sse_reduce]=ident_fra_reg_new(P,y,n,update_n)

%modified by Jing Deng on 12th January 2010
% P: full regression matrix, y: output; n: number of terms to be selected
% iSels: index of terms selected; s: model coefficients; A: intermediate regression context;
%update_n specifies how many cycles to update the regularisation
%parameters.
% clear all;
% close all;
% load code_test.mat
% p = P;
% y = t;
% update_n = 10;
% n = 16;
	[N,m]=size(P);
    Lambda = 0.001 * ones(m,1);
    cycle_count = 0;
    index = 1:m;
while cycle_count < update_n;

	A=zeros(n,m);
    sse_y = y'*y;
	a=zeros(n,1);
    B = zeros(n,n);
    C = zeros(n,n);
    sse_reduce = [];
    %%%%%%%%%%%%%%%%%%%%%%%%%i0rder=term-index%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	iOrder=1:m;
    %%%%%%%%%%Ay i.e. numerator of formula 31, Here give Ay initial value%%%%%%%%%%%%%%%%%%%%%%%
	Ay=y'*P;										% 1*m
    %%%%%%%%%%Norm2 i.e. denominator of formula 31, Here give Norm2 initial value%%%%%%%%%%%%%%%%%%%%%%%
	Norm2=sum(P.*P); 							% 1*m
	for k=1:n
		reod=iOrder(k:m);
		Reduces=Ay(reod).^2./(Norm2(reod)+Lambda(reod)');	% 1*(n-k)
		[fMaxReduce,iMax]=max(Reduces);
        sse_reduce = [sse_reduce,fMaxReduce];
        sse_y = sse_y - fMaxReduce;
		reod([1,iMax])=reod([iMax,1]);    %exchange index position
		cs=reod(1);
		reod=reod(2:end);                           %the left model terms
		s=P(:,cs)'*P(:,reod);						% (m-k)*[N-1,N]   %%%phi_k^T*phi_i not including the selected kth term
		for q=1:k-1
			s=s-A(q,cs)/(A(q,iOrder(q)) + Lambda(iOrder(q)))*A(q,reod);	% [m-k,m-k+1] % to evaluation a_ki  A(q,iOrder(q))=ajj
    
		end
		A(k,[cs,reod])=[Norm2(cs),s];               % update matrix A
        iOrder(k:m)=[cs,reod];                      % sort-seleted index remaining index
        
        for q = 1:k-1
                    B(k,iOrder(q)) = A(q,iOrder(k))/(A(q,iOrder(q)) + Lambda(iOrder(q))); %update matrix B
            for l = q+1:k-1
                B(k,iOrder(q)) = B(k,iOrder(q)) - A(l,iOrder(k))*B(l,iOrder(q))/((A(l,iOrder(l)) + Lambda(iOrder(l))));
            end
            C(iOrder(q),k) = Ay(iOrder(q))/(((A(q,iOrder(q)) + Lambda(iOrder(q)))));
            for l = q+1:k-1
                C(iOrder(q),k) = C(iOrder(q),k) - Ay(iOrder(l))*B(l,iOrder(q))/((A(l,iOrder(l)) + Lambda(iOrder(l))));
            end
        end
                  
        %%%%%%%%%%%%%%up-compute kth A %%%%%%%%%%%%%%
        %%%%%%%%%%%%%%%%down-k+1%%%%%%%%%%%%%%%%%%%%%%%

		if k<n
			s=Ay(cs)/(A(k,cs)+Lambda(cs))*A(k,reod);				% [0,m-k+1]
			Ay(reod)=Ay(reod)-s;					% [m-k,0]
			s=A(k,reod).*A(k,reod)/(A(k,cs)+Lambda(cs));			% [0,m-k+1]
			Norm2(reod)=Norm2(reod)-s;				% [m-k,0]
        end       
    end
    
%calculate the model parameters
    for q=1:n
        C(iOrder(q),n+1) = Ay(iOrder(q))/(((A(q,iOrder(q)) + Lambda(iOrder(q)))));
        for l = q+1:n
            C(iOrder(q),n+1) = C(iOrder(q),n+1) - Ay(iOrder(l))*B(l,iOrder(q))/((A(l,iOrder(l)) + Lambda(iOrder(l))));
        end
    end
     a = C(iOrder(1:n),k+1);
     
% to calculate the diagonal elements of inverse M_k which is h_i
    d = 1/(A(1,iOrder(1)) + Lambda(iOrder(1)));
    h = d;
    for q = 2:n
        d = 1/(A(q,iOrder(q)) + Lambda(iOrder(q)));
        h = [h + d*B(q,iOrder(1:q-1)).^2,d];
    end
 % to update regularisation parameters
 gamma = ones(n,1) - Lambda(iOrder(1:n)).*h';
 Gamma2 = n - h*Lambda(iOrder(1:n));
 Gamma = sum(gamma);
 
 Lambda(iOrder(1:n)) = sse_y/(N-Gamma)*gamma./(a.^2);
 
  for i = 1:n
     if Lambda(iOrder(i)) > 1e15
         Lambda(iOrder(i)) = 1e15;
     end
 end
 
 cycle_count = cycle_count + 1;
 term_sel_record(cycle_count,:) = iOrder(1:n);
 index = index(iOrder(1:n));
 
 P = P(:,iOrder(1:n));
 [N,m]=size(P);
  Lambda = Lambda(iOrder(1:n));
  
end
    iSels = index;
	A=[A(:,iOrder(1:n)),Ay(iOrder(1:n))'];

	return;

    
    
    
    
    
    
    
    
    
    
    
    
    