function [iSels,a,A]=fra(P,Y,n)
%version: 1.0 
%data: 13/04/2010 
%Programmer: Jing Deng
%this function can be used for both MISO and MIMO models without output
%feedback
% P: full regression matrix (N*M), Y: output matrix(N*r); n: number of terms to be selected
% iSels: index of terms selected; s: model coefficients; A: intermediate regression context; 
load test_code_mul.mat
Y = t(1,:)';
n = 10;
	[N,m]=size(P);
    r = length(Y(1,:));
    %%%%%%%%%%%%[a11, a12,a13,......,a1m]
    %%%%%%%%%%A=[0,   a22,a23,......,a2m]
    %%%%%%%%%%%%[.......................]
    %%%%%%%%%%%%[0,     0,  0,......,anm]
	A=zeros(n,m);
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%theat %%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%[a11]
    %%%%%%%%%%%%%%%%%%%%a=[a21]
    %%%%%%%%%%%%%%%%%%%%%%[...]
    %%%%%%%%%%%%%%%%%%%%%%[an1]
	a=zeros(n,r);
    sse_reduce = [];
    sse_red_sum = 0;
    %%%%%%%%%%%%%%%%%%%%%%%%%i0rder=term-index%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	iOrder=1:m;
    %%%%%%%%%%Ay i.e. numerator of formula 31, Here give Ay initial value%%%%%%%%%%%%%%%%%%%%%%%
	Ay=Y'*P;										% q*M matrix
    %%%%%%%%%%Norm2 i.e. denominator of formula 31, Here give Norm2 initial value%%%%%%%%%%%%%%%%%%%%%%%
	Norm2=sum(P.*P);								% m*[N-1,N]
	for k=1:n
		reod=iOrder(k:m);
        Reduces=sum(Ay(:,reod).*Ay(:,reod),1)./Norm2(reod);  %calculate the contribution of rest candidate terms
		[fMaxReduce,iMax]=max(Reduces);
        sse_red_sum = sse_red_sum + fMaxReduce;
        sse_reduce = [sse_reduce,fMaxReduce];
		reod([1,iMax])=reod([iMax,1]);    %exchange index position
		cs=reod(1);
		reod=reod(2:end);                           %the left model terms
		s=P(:,cs)'*P(:,reod);						% (m-k)*[N-1,N]   %%%phi_k^T*phi_i not including the selected kth term
		for q=1:k-1
			s=s-A(q,cs)/A(q,iOrder(q))*A(q,reod);	% [m-k,m-k+1] % to evaluation a_ki  A(q,cs)=ajj
		end
		A(k,[cs,reod])=[Norm2(cs),s];               % resume orginal position
        
        %%%%%%%%%%%%%%up-compute kth A %%%%%%%%%%%%%%
        %%%%%%%%%%%%%%%%down-k+1%%%%%%%%%%%%%%%%%%%%%%%
		iOrder(k:m)=[cs,reod];                      % sort-seleted index remaining index
		if k<n
			s=Ay(:,cs)/A(k,cs)*A(k,reod);				% [q,m-k+1]
			Ay(:,reod)=Ay(:,reod)-s;					% [m-k,0]
			s=A(k,reod).*A(k,reod)/A(k,cs);			% [0,m-k+1]
			Norm2(reod)=Norm2(reod)-s;				% [m-k,0]
		end
    end
    A = A(1:n,:);
    a = a(1:n,:);
	for k=n:-1:1
		cs=iOrder(k);  % the final order
		reod=iOrder(k+1:n);
		a(k,:)=Ay(:,cs)-(A(k,reod)*a(k+1:n,:))';				% [n-k,n-k]
		a(k,:)=a(k,:)/A(k,cs);							% [0,1]
	end
	iSels=iOrder(1:n);
	A=[A(:,iOrder(1:n)),Ay(:,iOrder(1:n))'];
	return;
