function [iSels,a,A,lambda,Gamma]=ident_fra_loo_reg1(P,y,c,update_n)

%modified by Jing Deng on 22th February 2010
% this code is only used for binomial classification problems
% P: full regression matrix, y: output; n: number of terms to be selected
% iSels: index of terms selected; s: model coefficients; A: intermediate regression context;
%update_n specifies how many cycles to update the regularisation
%parameters.
% clear all;
% close all;
% load data_bana_test.mat
% % p = P;
% P = p;
% y = t;
% update_n = 10;
% n = 22;
	[N,m]=size(P);
    lambda = 0.001 * ones(1,m);
    cycle_count = 0;
    index = 1:m;
    y_temp = y.*(y-c*ones(N,1))*ones(1,m);
while cycle_count < update_n;

	d_im = [];
    e_im = [];
    reod = [];
    A=zeros(m,m);
    a = zeros(m,1);
    k = 0;  % the initial order of selected terms
    iOrder=1:m;  %the initial terms that were selected
    term_pool = 1:m;  % The initial candidate term pool
%     J_0 = mean(y.^2)+0.00001;  %make sure the initial value of J_k0 is large than J_k1, so the following cycle can start
    J_1 = mean(y.^2);
    stop_flag = 1;
    Ay=y'*P;	
    Ad=sum(P.*P);
    P_im = P;
    J_1 = N;
    
    d_im = ones(N,m) - P_im.^2./(ones(N,1)*(Ad+lambda));
    e_im = y*ones(1,m)- P_im.*(ones(N,1)*(Ay./(Ad+lambda)));
    J_record = [];

	while stop_flag
		k = k+1;
        J_0 = J_1;
        reod=iOrder(k:m);
%         J = sum((e_im(:,reod)./d_im(:,reod)).^2)/N;	% (m-k+1)*[0,2]

        J = y_temp(:,1:m-k+1) - y*ones(1,m-k+1).*e_im(:,reod)./d_im(:,reod);                       
        J_comp = sum(J<0); 

		[fMaxReduce,iMax]= min(J_comp);
        J_record = [J_record,fMaxReduce];
		reod([1,iMax])=reod([iMax,1]);    %exchange index position
        J_1 = fMaxReduce;
		cs=reod(1);
		reod=reod(2:end);                           %the left model terms
		s=P(:,cs)'*P(:,reod);						% (m-k)*[N-1,N]   %%%phi_k^T*phi_i not including the selected kth term
		for q=1:k-1
			s=s-A(q,cs)/(A(q,iOrder(q)) + lambda(iOrder(q)))*A(q,reod);	% [m-k,m-k+1] % to evaluation a_ki  A(q,iOrder(q))=ajj
    
		end
		A(k,[cs,reod])=[Ad(cs),s];               % update matrix A
        iOrder(k:m)=[cs,reod];                      % sort-seleted index remaining index
        
        for q = 1:k-1
                    B(k,iOrder(q)) = A(q,iOrder(k))/(A(q,iOrder(q)) + lambda(iOrder(q))); %update matrix B
            for l = q+1:k-1
                B(k,iOrder(q)) = B(k,iOrder(q)) - A(l,iOrder(k))*B(l,iOrder(q))/((A(l,iOrder(l)) + lambda(iOrder(l))));
            end
            C(iOrder(q),k) = Ay(iOrder(q))/(((A(q,iOrder(q)) + lambda(iOrder(q)))));
            for l = q+1:k-1
                C(iOrder(q),k) = C(iOrder(q),k) - Ay(iOrder(l))*B(l,iOrder(q))/((A(l,iOrder(l)) + lambda(iOrder(l))));
            end
        end
                  
        %%%%%%%%%%%%%%up-compute kth A %%%%%%%%%%%%%%
        %%%%%%%%%%%%%%%%down-k+1%%%%%%%%%%%%%%%%%%%%%%%

		if k<m
			s=Ay(cs)/(A(k,cs)+lambda(cs))*A(k,reod);				% [0,m-k+1]
			Ay(reod)=Ay(reod)-s;					% [m-k,0]
			s=A(k,reod).*A(k,reod)/(A(k,cs)+lambda(cs));			% [0,m-k+1]
			Ad(reod)=Ad(reod)-s;				% [m-k,0]
            P_im(:,reod) = P_im(:,reod) - P_im(:,cs)*(A(k,reod)/(A(k,cs)+lambda(cs)));
            d_im(:,reod) = d_im(:,cs)*ones(1,m-k) - P_im(:,reod).^2./(ones(N,1)*(Ad(reod)+lambda(reod)));
            e_im(:,reod) = e_im(:,cs)*ones(1,m-k)- P_im(:,reod).*(ones(N,1)*(Ay(reod)./(Ad(reod)+lambda(reod))));
        end    
         %% determin the stop point  %%%%% J_0 < J_1
         if cycle_count == 0
            if k == 40
                stop_flag = 0;
            end
         end
        if k == m
            stop_flag = 0;
        end
            
    end

    n = k;
%calculate the model parameters
    for q=1:n
        C(iOrder(q),n+1) = Ay(iOrder(q))/(((A(q,iOrder(q)) + lambda(iOrder(q)))));
        for l = q+1:n
            C(iOrder(q),n+1) = C(iOrder(q),n+1) - Ay(iOrder(l))*B(l,iOrder(q))/((A(l,iOrder(l)) + lambda(iOrder(l))));
        end
    end
     a = C(iOrder(1:n),k+1);
     
% to calculate the diagonal elements of inverse M_k which is h_i
    d = 1/(A(1,iOrder(1)) + lambda(iOrder(1)));
    h = d;
    for q = 2:n
        d = 1/(A(q,iOrder(q)) + lambda(iOrder(q)));
        h = [h + d*B(q,iOrder(1:q-1)).^2,d];
    end
 % to update regularisation parameters
 gamma = ones(1,n) - lambda(iOrder(1:n)).*h;
%  Gamma2 = n - h*lambda(iOrder(1:n));
 Gamma = sum(gamma);
 
 error = y - P(:,iOrder(1:n))*a;
 sse_y = sse(error);
 
 lambda(iOrder(1:n)) =sum(e_im(:,iOrder(n)).^2)/(N-Gamma)*gamma./(a.^2)';
 
  for i = 1:n
     if lambda(iOrder(i)) > 1e15
         lambda(iOrder(i)) = 1e15;
     end
 end
 
 cycle_count = cycle_count + 1;
%  term_sel_record(cycle_count,:) = iOrder(1:n);
 index = index(iOrder(1:n));
 
 P = P(:,iOrder(1:n));
 [N,m]=size(P);
  lambda = lambda(iOrder(1:n));
  
end
    iSels = index;
	A=[A(:,iOrder(1:n)),Ay(iOrder(1:n))'];

	return;

    
    
    
    
    
    
    
    
    
    
    
    
    